diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1288,18 +1413,72 @@ class SquadService extends Actor {
         }
 
       case msg =>
-        log.info(s"Unhandled message $msg from $sender")
+        debug(s"Unhandled message $msg from $sender")
+    }
+
+    case data @ SquadResponse.WantsSquadPosition(leader_char_id, _) =>
+      Publish(leader_char_id, data)
+
+    case msg =>
+      debug(s"Unhandled message $msg from $sender")
+  }
+
+  /**
+    * This player has refused to join squad leader's squads or some other players's offers to form a squad.
+    * @param charId the player who refused other players
+    * @return the list of other players who have been refused
+    */
+  def Refused(charId : Long) : List[Long] = refused.getOrElse(charId, Nil)
+
+  /**
+    * This player has refused to join squad leader's squads or some other players's offers to form a squad.
+    * @param charId the player who is doing the refusal
+    * @param refusedCharId the player who is refused
+    * @return the list of other players who have been refused
+    */
+  def Refused(charId : Long, refusedCharId : Long) : List[Long] = {
+    if(charId != refusedCharId) {
+      Refused(charId, List(refusedCharId))
+    }
+    else {
+      Nil
     }
   }
 
   /**
-    * na
-    * @param invitedPlayer the person who will handle the invitation, eventually if not immediately
+    * This player has refused to join squad leader's squads or some other players's offers to form a squad.
+    * @param charId the player who is doing the refusal
+    * @param list the players who are refused
+    * @return the list of other players who have been refused
+    */
+  def Refused(charId : Long, list : List[Long]) : List[Long] = {
+    refused.get(charId) match {
+      case Some(refusedList) =>
+        refused(charId) = list ++ refusedList
+        Refused(charId)
+      case None =>
+        Nil
+    }
+  }
+
+  /**
+    * Assign a provided invitation object to either the active or inactive position for a player.<br>
+    * <br>
+    * The determination for the active position is whether or not something is currently in the active position
+    * or whether some mechanism tried to shift invitation object into the active position
+    * but found nothing to shift.
+    * If an invitation object originating from the reported player already exists,
+    * a new one is not appended to the inactive queue.
+    * This method should always be used as the entry point for the active and inactive invitation options
+    * or as a part of the entry point for the aforesaid options.
+    * @see `AddInviteAndRespond`
+    * @see `AltAddInviteAndRespond`
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object
     * @param invite the "new" invitation envelop object
     * @return an optional invite;
-    *         if added to the active invite position, return the parameter bid;
-    *         if added to the queued invite, return the invite in the active position;
-    *         if not added, return `None`
+    *         the invitation object in the active invite position;
+    *         `None`, if it is not added to either the active option or inactive position
     */
   def AddInvite(invitedPlayer : Long, invite : Invitation) : Option[Invitation] = {
     invites.get(invitedPlayer).orElse(previousInvites.get(invitedPlayer)) match {
@@ -1309,10 +1488,9 @@ class SquadService extends Actor {
           case Some(bidList) =>
             //ensure that new invite does not interact with the queue's invites by invitingPlayer info
             if(_bid.InviterCharId != invite.InviterCharId && !bidList.exists { eachBid => eachBid.InviterCharId == invite.InviterCharId }) {
-              log.debug(s"Invite from ${invite.InviterCharId} to $invitedPlayer stored in queue while active invite request pending")
               queuedInvites(invitedPlayer) = invite match {
-                case _: BidForRole =>
-                  val (normals, others) = bidList.partition(_.isInstanceOf[BidForRole])
+                case _: RequestRole =>
+                  val (normals, others) = bidList.partition(_.isInstanceOf[RequestRole])
                   (normals :+ invite) ++ others
                 case _ =>
                   bidList :+ invite
@@ -1324,7 +1502,6 @@ class SquadService extends Actor {
             }
           case None =>
             if(_bid.InviterCharId != invite.InviterCharId) {
-              log.debug(s"Invite from ${invite.InviterCharId} to $invitedPlayer stored while active invite request pending")
               queuedInvites(invitedPlayer) = List[Invitation](invite)
               Some(_bid)
             }
@@ -1339,44 +1516,150 @@ class SquadService extends Actor {
     }
   }
 
-  def RemoveInvite(invitedPlayer : Long) : Option[Invitation] = {
-    invites.remove(invitedPlayer) match {
-      case out @ Some(invite) =>
-        previousInvites += invitedPlayer -> invite
-        out
-      case None =>
-        None
+  /**
+    * Component method used for the response behavior for processing the invitation object as an `IndirectInvite` object.
+    * @see `HandleRequestRole`
+    * @param invite the original invitation object that started this process
+    * @param player the target of the response and invitation
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object;
+    *                      not useful here
+    * @param invitingPlayer the unique character identifier for the player who invited the former;
+    *                       not useful here
+    * @param name a name to be used in message composition;
+    *             not useful here
+    * @return na
+    */
+  def indirectInviteResp(invite : IndirectInvite, player : Player, invitedPlayer : Long, invitingPlayer : Long, name : String) : Boolean = {
+    HandleRequestRole(invite, player)
+  }
+
+  /**
+    * Component method used for the response behavior for processing the invitation object as an `IndirectInvite` object.
+    * @see `HandleRequestRole`
+    * @param invite the original invitation object that started this process
+    * @param player the target of the response and invitation
+    * @param invitedPlayer the unique character identifier for the player being invited
+    *                      in actuality, represents the player who will address the invitation object
+    * @param invitingPlayer the unique character identifier for the player who invited the former
+    * @param name a name to be used in message composition
+    * @return na
+    */
+  def altIndirectInviteResp(invite : IndirectInvite, player : Player, invitedPlayer : Long, invitingPlayer : Long, name : String) : Boolean = {
+    Publish(invitingPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), player.Name, false, Some(None)))
+    HandleRequestRole(invite, player)
+  }
+
+  /**
+    * A branched response for processing (new) invitation objects that have been submitted to the system.<br>
+    * <br>
+    * A comparison is performed between the original invitation object and an invitation object
+    * that represents the potential modification or redirection of the current active invitation obect.
+    * Any further action is only performed when an "is equal" comparison is `true`.
+    * When passing, the system publishes up to two messages
+    * to users that would anticipate being informed of squad join activity.
+    * @param indirectVacancyFunc the method that cans the respondign behavior should an `IndirectVacancy` object being consumed
+    * @param targetInvite a comparison invitation object;
+    *                     represents the unmodified, unadjusted invite
+    * @param actualInvite a comparaison invitation object;
+    *                     proper use of this field should be the output of another process upon the following `actualInvite`
+    * @param invitedPlayer the unique character identifier for the player being invited
+    *                      in actuality, represents the player who will address the invitation object
+    * @param invitingPlayer the unique character identifier for the player who invited the former
+    * @param name a name to be used in message composition
+    */
+  def InviteResponseTemplate(indirectVacancyFunc : (IndirectInvite, Player, Long, Long, String) => Boolean)(targetInvite : Invitation, actualInvite : Option[Invitation], invitedPlayer : Long, invitingPlayer : Long, name : String) : Unit = {
+    if(actualInvite.contains(targetInvite)) {
+      //immediately respond
+      targetInvite match {
+        case VacancyInvite(charId, _name, _) =>
+          Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Invite, 0, 0, charId, Some(invitedPlayer), _name, false, Some(None)))
+          Publish(charId, SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, true, Some(None)))
+
+        case _bid @ IndirectInvite(player, _) =>
+          indirectVacancyFunc(_bid, player, invitedPlayer, invitingPlayer, name)
+
+        case _bid @ SpontaneousInvite(player) =>
+          val bidInvitingPlayer = _bid.InviterCharId
+          Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bidInvitingPlayer, Some(invitedPlayer), player.Name, false, Some(None)))
+          Publish(bidInvitingPlayer, SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(bidInvitingPlayer), player.Name, true, Some(None)))
+
+        case _bid @ RequestRole(player, _, _) =>
+          HandleRequestRole(_bid, player)
+
+        case LookingForSquadRoleInvite(charId, _name, _, _) =>
+          Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, false, Some(None)))
+
+        case ProximityInvite(charId, _name, _) =>
+          Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), _name, false, Some(None)))
+
+        case _ =>
+          log.warn(s"AddInviteAndRespond: can not parse discovered unhandled invitation type - $targetInvite")
+      }
     }
   }
 
-  def RemoveQueuedInvites(invitedPlayer : Long) : List[Invitation] = {
-    queuedInvites.remove(invitedPlayer) match {
-      case Some(_bidList) => _bidList
-      case None => Nil
-    }
+  /**
+    * Enqueue a newly-submitted invitation object
+    * either as the active position or into the inactive positions
+    * and dispatch a response for any invitation object that is discovered.
+    * Implementation of a workflow.
+    * @see `AddInvite`
+    * @see `indirectInviteResp`
+    * @param targetInvite a comparison invitation object
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object
+    * @param invitingPlayer the unique character identifier for the player who invited the former
+    * @param name a name to be used in message composition
+    */
+  def AddInviteAndRespond(invitedPlayer : Long, targetInvite : Invitation, invitingPlayer : Long, name : String) : Unit = {
+    InviteResponseTemplate(indirectInviteResp)(
+      targetInvite,
+      AddInvite(invitedPlayer, targetInvite),
+      invitedPlayer,
+      invitingPlayer,
+      name
+    )
   }
 
-  def RemoveInvites(invitedPlayer : Long, invitingPlayer : Long) : Unit = {
-    queuedInvites.get(invitedPlayer) match {
-      case Some(bidList) =>
-        val list = bidList.filterNot { _.InviterCharId == invitingPlayer }
-        if(list.nonEmpty) {
-          queuedInvites(invitedPlayer) = list
-        }
-        else {
-          queuedInvites.remove(invitedPlayer)
-        }
-      case None => ;
-    }
-    invites.get(invitedPlayer) match {
-      case Some(_bid) =>
-        if(_bid.InviterCharId == invitingPlayer) {
-          //drop bid, try reload new bid
-        }
-      case None => ;
-    }
+  /**
+    * Enqueue a newly-submitted invitation object
+    * either as the active position or into the inactive positions
+    * and dispatch a response for any invitation object that is discovered.
+    * Implementation of a workflow.
+    * @see `AddInvite`
+    * @see `altIndirectInviteResp`
+    * @param targetInvite a comparison invitation object
+    * @param invitedPlayer the unique character identifier for the player being invited
+    * @param invitingPlayer the unique character identifier for the player who invited the former
+    * @param name a name to be used in message composition
+    */
+  def AltAddInviteAndRespond(invitedPlayer : Long, targetInvite : Invitation, invitingPlayer : Long, name : String) : Unit = {
+    InviteResponseTemplate(altIndirectInviteResp)(
+      targetInvite,
+      AddInvite(invitedPlayer, targetInvite),
+      invitedPlayer,
+      invitingPlayer,
+      name
+    )
   }
 
+  /**
+    * Select the next invitation object to be shifted into the active position.<br>
+    * <br>
+    * The determination for the active position is whether or not something is currently in the active position
+    * or whether some mechanism tried to shift invitation object into the active position
+    * but found nothing to shift.
+    * After handling of the previous invitation object has completed or finished,
+    * the temporary block on adding new invitations is removed
+    * and any queued inactive invitation on the head of the inactive queue is shifted into the active position.
+    * @see `NextInviteAndRespond`
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object
+    * @return an optional invite;
+    *         the invitation object in the active invite position;
+    *         `None`, if not shifted into the active position
+    */
   def NextInvite(invitedPlayer : Long) : Option[Invitation] = {
     previousInvites.remove(invitedPlayer)
     invites.get(invitedPlayer) match {
@@ -1404,166 +1687,106 @@ class SquadService extends Actor {
     }
   }
 
-  def HandleVacancyInvite(squad_guid : PlanetSideGUID, invitedPlayer : Long, invitingPlayer : Long, recruit : Player) : Option[(Squad, Int)] = {
-    //accepted an invitation to join an existing squad
-    if(squadFeatures.get(squad_guid).isEmpty) {
-      log.warn(s"Accept->Invite: the squad #${squad_guid.guid} no longer exists")
-      None
-    }
-    else if(memberToSquad.get(invitedPlayer).nonEmpty) {
-      log.warn(s"Accept->Invite: ${recruit.Name} is already a member of a squad and can not join squad #${squad_guid.guid}")
-      None
-    }
-    else {
-      val squad = squadFeatures(squad_guid).Squad
-      if(!squad.AutoApproveInvitationRequests && squad.Leader.CharId != invitingPlayer) {
-        //the inviting player was not the squad leader and this decision should be bounced off the squad leader
-        AltAddInviteAndRespond(
-          squad.Leader.CharId,
-          IndirectInvite(recruit, squad_guid),
-          invitingPlayer,
-          name = ""
+  /**
+    * Select the next invitation object to be shifted into the active position
+    * and dispatch a response for any invitation object that is discovered.
+    * @see `InviteResponseTemplate`
+    * @see `NextInvite`
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object
+    * @return an optional invite;
+    *         the invitation object in the active invite position;
+    *         `None`, if not shifted into the active position
+    */
+  def NextInviteAndRespond(invitedPlayer : Long) : Unit = {
+    NextInvite(invitedPlayer) match {
+      case Some(invite) =>
+        InviteResponseTemplate(indirectInviteResp)(
+          invite,
+          Some(invite),
+          invitedPlayer,
+          invite.InviterCharId,
+          invite.InviterName
         )
-        log.info(s"Accept->Invite: ${recruit.Name} must await an invitation from the leader of squad #${squad_guid.guid}")
+      case None => ;
+    }
+  }
+
+  /**
+    * Remove any invitation object from the active position.
+    * Flag the temporary field to indicate that the active position, while technically available,
+    * should not yet have a new invitation object shifted into it yet.
+    * This is the "proper" way to demote invitation objects from the active position
+    * whether or not they are to be handled.
+    * @see `NextInvite`
+    * @see `NextInviteAndRespond`
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object
+    * @return an optional invite;
+    *         the invitation object formerly in the active invite position;
+    *         `None`, if no invitation was in the active position
+    */
+  def RemoveInvite(invitedPlayer : Long) : Option[Invitation] = {
+    invites.remove(invitedPlayer) match {
+      case out @ Some(invite) =>
+        previousInvites += invitedPlayer -> invite
+        out
+      case None =>
         None
-      }
-      else {
-        //if a suitable position in the squad can be found, player may occupy it
-        squad.Membership.zipWithIndex.find({ case (member, index) =>
-          ValidOpenSquadPosition(squad, index, member, recruit.Certifications)
-        }) match {
-          case Some((_, line)) =>
-            Some((squad, line))
-          case _ =>
-            if(squad.Size == squad.Capacity) {
-              log.warn(s"Accept->Invite: squad #${squad_guid.guid} is already full and ${recruit.Name} can not join it")
-            }
-            else {
-              log.warn(s"Accept->Invite: squad #${squad_guid.guid} has no positions available that satisfy ${recruit.Name}")
-            }
-            None
-        }
-      }
     }
   }
 
-  def InitialAssociation(squad : Squad) : Boolean = {
-    val guid = squad.GUID
-    if(squadFeatures(guid).InitialAssociation) {
-      squadFeatures(guid).InitialAssociation = false
-      val charId = squad.Leader.CharId
-      SquadEvents.publish(
-        SquadServiceResponse(s"/$charId/Squad", SquadResponse.AssociateWithSquad(guid))
-      )
-      SquadEvents.publish(
-        SquadServiceResponse(s"/$charId/Squad", SquadResponse.Detail(
-          guid,
-          SquadService.Detail.Publish(squad))
-        )
-      )
-    }
-    false
-  }
-
-  def HandleBidForRole(bid : BidForRole, player : Player) : Boolean = {
-    HandleBidForRole(bid, bid.squad_guid, bid.player.Name, player)
-  }
-  def HandleBidForRole(bid : IndirectInvite, player : Player) : Boolean = {
-    HandleBidForRole(bid, bid.squad_guid, bid.player.Name, player)
-  }
-
-  def HandleBidForRole(bid : Invitation, squad_guid : PlanetSideGUID, name : String, player : Player) : Boolean = {
-    GetSquad(squad_guid) match {
-      case Some(squad) =>
-        val leaderCharId = squad.Leader.CharId
-        if(squad.AutoApproveInvitationRequests) {
-          self ! SquadServiceMessage(player, Zone.Nowhere, SquadAction.Membership(SquadRequestType.Accept, leaderCharId, None, "", None))
-        }
-        else {
-          SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.WantsSquadPosition(name)))
-        }
-        true
-      case _ =>
-        //squad is missing; will this properly short-circuit?
-        log.error(s"Attempted to process ${bid.InviterName}'s bid for a position in a squad (id:${squad_guid.guid}) that does not exist")
-        false
-    }
-  }
-
-  def JoinSquad(player : Player, squad : Squad, line : Int) : Boolean = {
-    val charId = player.CharId
-    val position = squad.Membership(line)
-    if(ValidOpenSquadPosition(squad, line, position, player.Certifications)) {
-      log.info(s"Player ${player.Name} will join the squad ${squad.Task} at position ${line+1}!")
-      position.Name = player.Name
-      position.CharId = charId
-      position.Health = StatConverter.Health(player.Health, player.MaxHealth, min=1, max=64)
-      position.Armor = StatConverter.Health(player.Armor, player.MaxArmor, min=1, max=64)
-      position.Position = player.Position
-      position.ZoneId = 13
-      memberToSquad(charId) = squad
-
-      InitialAssociation(squad)
-      SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.AssociateWithSquad(squad.GUID)) )
-      val size = squad.Size
-      if(size == 1) {
-        //leader joins the squad? do nothing?
-        squad.LeaderPositionIndex = line
-      }
-      else if(size == 2) {
-        //first squad member after leader; both members fully initialize
-        val indices = squad.Membership.zipWithIndex
-          .collect({ case (member, index) if member.CharId != 0 => index }).toList
-        squad.Membership
-          .filterNot { _.CharId == 0 }
-          .foreach { member =>
-            SquadEvents.publish(SquadServiceResponse(s"/${member.CharId}/Squad", SquadResponse.Join(squad, indices)))
-            InitWaypoints(member.CharId, squad.GUID)
-          }
-        //fully update for all users
-        UpdateSquadDetail(squad.GUID, squad)
-      }
-      else {
-        //joining an active squad; everybody updates differently
-        //new member gets full squad UI updates
-        val indices = squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
-        SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Join(squad, indices)))
-        InitSquadDetail(squad.GUID, Seq(charId), squad)
-        InitWaypoints(charId, squad.GUID)
-        //other squad members see new member joining the squad
-        val updatedIndex = List(line)
-        val otherMembers = squad.Membership.filterNot { member => member.CharId == 0 || member.CharId == charId }.map{ _.CharId }
-        otherMembers.foreach { member =>
-          SquadEvents.publish(SquadServiceResponse(s"/$member/Squad", SquadResponse.Join(squad, updatedIndex)))
-        }
-        val details = SquadDetail().Members(List(SquadPositionEntry(line, SquadPositionDetail().CharId(charId).Name(player.Name))))
-        UpdateSquadDetail(squad.GUID, otherMembers, details)
-      }
-      UpdateSquadListWhenListed(squad, SquadInfo().Size(size))
-      true
-    }
-    else {
-      false
+  /**
+    * Remove all inactive invites.
+    * @param invitedPlayer the unique character identifier for the player being invited;
+    *                      in actuality, represents the player who will address the invitation object
+    * @return a list of the removed inactive invitation objects
+    */
+  def RemoveQueuedInvites(invitedPlayer : Long) : List[Invitation] = {
+    queuedInvites.remove(invitedPlayer) match {
+      case Some(_bidList) => _bidList
+      case None => Nil
     }
   }
 
+  /**
+    * Remove all active invitation objects that are related to the particular squad and the particular role in the squad.
+    * Specifically used to safely disarm obsolete invitation objects related to the specific criteria.
+    * Affects only certain invitation object types.
+    * @see `RequestRole`
+    * @see `LookingForSquadRoleInvite`
+    * @see `RemoveInvite`
+    * @see `RemoveQueuedInvitesForSquadAndPosition`
+    * @param guid the squad identifier
+    * @param position the role position index
+    */
   def RemoveInvitesForSquadAndPosition(guid : PlanetSideGUID, position : Int) : Unit = {
     //eliminate active invites for this role
     invites.collect {
-      case(charId, InviteForRole(_,_, sguid, pos)) if sguid == guid && pos == position =>
+      case(charId, LookingForSquadRoleInvite(_,_, sguid, pos)) if sguid == guid && pos == position =>
         RemoveInvite(charId)
-      case (charId, BidForRole(_, sguid, pos)) if sguid == guid && pos == position =>
+      case (charId, RequestRole(_, sguid, pos)) if sguid == guid && pos == position =>
         RemoveInvite(charId)
     }
     RemoveQueuedInvitesForSquadAndPosition(guid, position)
   }
 
+  /**
+    * Remove all inactive invitation objects that are related to the particular squad and the particular role in the squad.
+    * Specifically used to safely disarm obsolete invitation objects by specific criteria.
+    * Affects only certain invitation object types.
+    * @see `RequestRole`
+    * @see `LookingForSquadRoleInvite`
+    * @see `RemoveInvitesForSquadAndPosition`
+    * @param guid the squad identifier
+    * @param position the role position index
+    */
   def RemoveQueuedInvitesForSquadAndPosition(guid : PlanetSideGUID, position : Int) : Unit = {
     //eliminate other invites for this role
     queuedInvites.foreach { case(charId, queue) =>
       val filtered = queue.filterNot {
-        case InviteForRole(_,_, sguid, pos) => sguid == guid && pos == position
-        case BidForRole(_, sguid, pos) => sguid == guid && pos == position
+        case LookingForSquadRoleInvite(_,_, sguid, pos) => sguid == guid && pos == position
+        case RequestRole(_, sguid, pos) => sguid == guid && pos == position
         case _ => false
       }
       if(filtered.isEmpty) {
@@ -1575,107 +1798,40 @@ class SquadService extends Actor {
     }
   }
 
-  def EnsureEmptySquad(char_id : Long, msg : String = "default warning message") : Boolean = {
-    memberToSquad.get(char_id) match {
-      case None =>
-        true
-      case Some(squad) if squad.Size == 1 =>
-        CloseSquad(squad)
-        true
-      case _ =>
-        log.warn(msg)
-        false
-    }
-  }
-
-  def LeaveSquad(charId : Long, squad : Squad) : Boolean = {
-    val membership = squad.Membership.zipWithIndex
-    membership.find { case (_member, _) => _member.CharId == charId } match {
-      case Some((member, index)) =>
-        val entry = (charId, index)
-        val updateList = entry +: membership
-          .collect { case (_member, _index) if _member.CharId > 0 && _member.CharId != charId => (_member.CharId, _index) }
-          .toList
-        //member leaves the squad completely
-        memberToSquad.remove(charId)
-        member.Name = ""
-        member.CharId = 0
-        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad, updateList)))
-        //other squad members see the member leaving
-        val leavingMember = List(entry)
-        membership
-          .filter { case (_member, _) => _member.CharId > 0 }
-          .foreach { case (_member, _) =>
-            SquadEvents.publish( SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Leave(squad, leavingMember)) )
-          }
-        UpdateSquadListWhenListed(squad, SquadInfo().Size(squad.Size))
-        UpdateSquadDetail(squad.GUID, squad,
-          SquadDetail().Members(List(SquadPositionEntry(index, SquadPositionDetail().Player(char_id = 0, name = ""))))
-        )
-        true
-      case None =>
-        false
-    }
-  }
-
-  def CloseSquad(squad : Squad) : Unit = {
-    val guid = squad.GUID
-    val membership = squad.Membership.zipWithIndex
-    val (updateMembers, updateIndices) = membership
-      .collect { case (member, index) if member.CharId > 0 => ((member, member.CharId, index), (member.CharId, index)) }
-      .unzip
-    val updateIndicesList = updateIndices.toList
-    val completelyBlankSquadDetail = SquadDetail().Complete
-    updateMembers
-      .foreach { case (member, charId, index) =>
-        memberToSquad.remove(charId)
-        member.Name = ""
-        member.CharId = 0L
-        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad,
-          updateIndicesList.filterNot { case (_, outIndex) => outIndex == index } :+ (charId, index) //we need to be last to leave to see the events
-        )) )
-        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.AssociateWithSquad(PlanetSideGUID(0))) )
-        SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Detail(PlanetSideGUID(0), completelyBlankSquadDetail)) )
-      }
-    UpdateSquadListWhenListed(squad, None)
-    CleanupInvitesForSquad(guid)
-    squadFeatures.remove(guid).get.Stop
-    TryResetSquadId()
-  }
-
-  def DisbandSquad(squad : Squad) : Unit = {
-    CloseSquad(squad)
-    val leader = squad.Leader.CharId
-    SquadEvents.publish(SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None))))
-    squad.Membership
-      .collect { case member if member.CharId > 0 && member.CharId != leader => member.CharId }
-      .foreach { charId =>
-        SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
-      }
-  }
-
-  def CleanupInvitesForSquad(squadGUID : PlanetSideGUID) : Unit = {
+  /**
+    * Remove all active and inactive invitation objects that are related to the particular squad.
+    * Specifically used to safely disarm obsolete invitation objects by specific criteria.
+    * Affects all invitation object types and all data structures that deal with the squad.
+    * @see `RequestRole`
+    * @see `IndirectInvite`
+    * @see `LookingForSquadRoleInvite`
+    * @see `ProximityInvite`
+    * @see `RemoveInvite`
+    * @see `VacancyInvite`
+    * @param sguid the squad identifier
+    */
+  def RemoveAllInvitesToSquad(sguid : PlanetSideGUID) : Unit = {
     //clean up invites
     invites.collect {
-      case (id, VacancyInvite(_, _, guid)) if squadGUID == guid =>
+      case (id, VacancyInvite(_, _, guid)) if sguid == guid =>
         RemoveInvite(id)
-      case (id, IndirectInvite(_, guid)) if squadGUID == guid =>
+      case (id, IndirectInvite(_, guid)) if sguid == guid =>
         RemoveInvite(id)
-      case (id, InviteForRole(_, _, guid, _)) if squadGUID == guid =>
+      case (id, LookingForSquadRoleInvite(_, _, guid, _)) if sguid == guid =>
         RemoveInvite(id)
-      case (id, BidForRole(_, guid, _)) if squadGUID == guid =>
+      case (id, RequestRole(_, guid, _)) if sguid == guid =>
         RemoveInvite(id)
-      case (id, ProximityInvite(_, _, guid)) if squadGUID == guid =>
+      case (id, ProximityInvite(_, _, guid)) if sguid == guid =>
         RemoveInvite(id)
     }
     //tidy the queued invitations
     queuedInvites.foreach { case(id, queue) =>
       val filteredQueue = queue.filterNot {
-        case VacancyInvite(_, _, guid) => squadGUID == guid
-        case IndirectInvite(_, guid) => squadGUID == guid
-        case InviteForRole(_, _, guid, _) => squadGUID == guid
-        case BidForRole(_, guid, _) => squadGUID == guid
-        case ProximityInvite(_, _, guid) => squadGUID == guid
+        case VacancyInvite(_, _, guid) => sguid == guid
+        case IndirectInvite(_, guid) => sguid == guid
+        case LookingForSquadRoleInvite(_, _, guid, _) => sguid == guid
+        case RequestRole(_, guid, _) => sguid == guid
+        case ProximityInvite(_, _, guid) => sguid == guid
         case _ => false
       }
       if(filteredQueue.isEmpty) {
